<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripInterfaceResult_v3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripInterfaceResult_v3 extends AbstractStructArrayBase
{
    /**
     * The TripInterfaceResult_v3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripInterfaceResult_v3[]
     */
    public $TripInterfaceResult_v3;
    /**
     * Constructor method for ArrayOfTripInterfaceResult_v3
     * @uses ArrayOfTripInterfaceResult_v3::setTripInterfaceResult_v3()
     * @param \StructType\TripInterfaceResult_v3[] $tripInterfaceResult_v3
     */
    public function __construct(array $tripInterfaceResult_v3 = array())
    {
        $this
            ->setTripInterfaceResult_v3($tripInterfaceResult_v3);
    }
    /**
     * Get TripInterfaceResult_v3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripInterfaceResult_v3[]|null
     */
    public function getTripInterfaceResult_v3()
    {
        return isset($this->TripInterfaceResult_v3) ? $this->TripInterfaceResult_v3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripInterfaceResult_v3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripInterfaceResult_v3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripInterfaceResult_v3ForArrayConstraintsFromSetTripInterfaceResult_v3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item) {
            // validation for constraint: itemType
            if (!$arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item instanceof \StructType\TripInterfaceResult_v3) {
                $invalidValues[] = is_object($arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item) ? get_class($arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item) : sprintf('%s(%s)', gettype($arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item), var_export($arrayOfTripInterfaceResult_v3TripInterfaceResult_v3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripInterfaceResult_v3 property can only contain items of type \StructType\TripInterfaceResult_v3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripInterfaceResult_v3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripInterfaceResult_v3[] $tripInterfaceResult_v3
     * @return \ArrayType\ArrayOfTripInterfaceResult_v3
     */
    public function setTripInterfaceResult_v3(array $tripInterfaceResult_v3 = array())
    {
        // validation for constraint: array
        if ('' !== ($tripInterfaceResult_v3ArrayErrorMessage = self::validateTripInterfaceResult_v3ForArrayConstraintsFromSetTripInterfaceResult_v3($tripInterfaceResult_v3))) {
            throw new \InvalidArgumentException($tripInterfaceResult_v3ArrayErrorMessage, __LINE__);
        }
        if (is_null($tripInterfaceResult_v3) || (is_array($tripInterfaceResult_v3) && empty($tripInterfaceResult_v3))) {
            unset($this->TripInterfaceResult_v3);
        } else {
            $this->TripInterfaceResult_v3 = $tripInterfaceResult_v3;
        }
        return $this;
    }
    /**
     * Add item to TripInterfaceResult_v3 value
     * @throws \InvalidArgumentException
     * @param \StructType\TripInterfaceResult_v3 $item
     * @return \ArrayType\ArrayOfTripInterfaceResult_v3
     */
    public function addToTripInterfaceResult_v3(\StructType\TripInterfaceResult_v3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripInterfaceResult_v3) {
            throw new \InvalidArgumentException(sprintf('The TripInterfaceResult_v3 property can only contain items of type \StructType\TripInterfaceResult_v3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripInterfaceResult_v3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripInterfaceResult_v3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripInterfaceResult_v3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripInterfaceResult_v3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripInterfaceResult_v3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripInterfaceResult_v3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripInterfaceResult_v3
     */
    public function getAttributeName()
    {
        return 'TripInterfaceResult_v3';
    }
}
